unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, ExportLV, StdCtrls, Menus, ExtCtrls, CheckState,
  SaveLV;

type
  TForm1 = class(TForm)
    ExportListView1: TExportListView;
    ListView1: TListView;
    ExportButton: TButton;
    ExportTypeComboBox: TComboBox;
    Label1: TLabel;
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    Exit1: TMenuItem;
    N2: TMenuItem;
    SaveAs1: TMenuItem;
    Save1: TMenuItem;
    Open1: TMenuItem;
    New1: TMenuItem;
    N1: TMenuItem;
    Options1: TMenuItem;
    MoreOptions1: TMenuItem;
    Option11: TMenuItem;
    Option21: TMenuItem;
    Option31: TMenuItem;
    OptionA1: TMenuItem;
    OptionB1: TMenuItem;
    OptionC1: TMenuItem;
    GroupBox1: TGroupBox;
    Panel1: TPanel;
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    Memo1: TMemo;
    TabSheet2: TTabSheet;
    Memo2: TMemo;
    TabSheet3: TTabSheet;
    Memo3: TMemo;
    SaveCheckState1: TSaveCheckState;
    N3: TMenuItem;
    More1: TMenuItem;
    Setting11: TMenuItem;
    Setting21: TMenuItem;
    Setting31: TMenuItem;
    InsertButton: TButton;
    TabSheet4: TTabSheet;
    Memo4: TMemo;
    TabSheet5: TTabSheet;
    Memo5: TMemo;
    SaveListView1: TSaveListView;
    Export1: TMenuItem;
    LetUserChooseEverything1: TMenuItem;
    procedure ExportButtonClick(Sender: TObject);
    procedure ExportTypeComboBoxChange(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure Option31Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure SaveListView1AllowSave(Allowed: Boolean);
    procedure SaveListView1AllowSaveAs(Allowed: Boolean);
    procedure New1Click(Sender: TObject);
    procedure Open1Click(Sender: TObject);
    procedure Save1Click(Sender: TObject);
    procedure SaveAs1Click(Sender: TObject);
    procedure InsertButtonClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure LetUserChooseEverything1Click(Sender: TObject);
    procedure ExportListView1ExportFinished(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

const
  cPleaseRegisterMsg     = 'Please register at ' + cComponentsWebSite;
  cPleaseRegisterHTMLMsg = 'Please click <A href="' + cComponentsWebSite + '">here</A> to register.';

// *** Begin TExportListView Code ***

procedure TForm1.ExportButtonClick(Sender: TObject);
begin
  // TExportListView: Exporting...
  with ExportListView1 do
  begin
    ExportType := TExportType(ExportTypeComboBox.ItemIndex); // Set Export Type
    Execute; // Export!
  end;
end;

procedure TForm1.ExportTypeComboBoxChange(Sender: TObject);
begin
  // TExportListView: Setting the Footer to a 'Please Register' Message
  with ExportTypeComboBox, ExportListView1 do
    if Items[ItemIndex] = 'HTML' then
      Footer := cPleaseRegisterHTMLMsg // If HTML, include link to web page
    else Footer := cPleaseRegisterMsg; // If not, just include address of web page
end;

procedure TForm1.FormShow(Sender: TObject);
begin
  // TExportListView: Set Export Type Combo Box
  ExportTypeComboBox.ItemIndex := 0; // Set to First Export Type
  ExportTypeComboBoxChange(Sender);

// *** End TExportListView Code ***
// *** Begin TSaveCheckState Code ***

  // TSaveCheckState: Load Check State
  SaveCheckState1.Load;
end;

procedure TForm1.Option31Click(Sender: TObject);
begin
  // TSaveCheckState: Toggle Checked State of the MenuItem
  with Sender as TMenuItem do
    Checked := not Checked;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  // TSaveCheckState: Save Check State
  SaveCheckState1.Save;
end;

// *** End TSaveCheckState Code ***
// *** Begin TSaveListView Code ***

procedure TForm1.SaveListView1AllowSave(Allowed: Boolean);
begin
  // TSaveListView: Enable/Disable Save Menu Items
  Save1.Enabled      := Allowed;
end;

procedure TForm1.SaveListView1AllowSaveAs(Allowed: Boolean);
begin
  // TSaveListView: Enable/Disable SaveAs and Export Buttons & Menu Items
  SaveAs1.Enabled            := Allowed;
  ExportButton.Enabled       := Allowed;
  ExportTypeComboBox.Enabled := Allowed;
end;

procedure TForm1.New1Click(Sender: TObject);
begin
  // TSaveListView: New Document
  ListView1.Items.Clear; // Just remove all data from the ListView
end;

procedure TForm1.Open1Click(Sender: TObject);
begin
  // TSaveListView: Open a Document
  SaveListView1.Open;
end;

procedure TForm1.Save1Click(Sender: TObject);
begin
  // TSaveListView: Save a Document
  SaveListView1.Save;
end;

procedure TForm1.SaveAs1Click(Sender: TObject);
begin
  // TSaveListView: SaveAs a Document
  SaveListView1.SaveAs;
end;

procedure TForm1.InsertButtonClick(Sender: TObject);
begin
  // TSaveListView: Insert a New Item to the ListView so you can see how
  // the OnAllow Events Work.
  with ListView1.Items.Add do
  begin
    Caption := 'Goodfellow';
    SubItems.Add('John');
    SubItems.Add('34');
    SubItems.Add('435-2456');
    SubItems.Add('Delphi Programmer!');
  end;
end;

// *** End TSaveListView Code ***
// *** Begin Misc. Code that you can ignore ***

procedure TForm1.Exit1Click(Sender: TObject);
begin
  // Exit
  Close;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  { TExportListView: Populate the Export Type ComboBox }
  ExportListView1.PopulateStrings(ExportTypeComboBox.Items);
end;

procedure TForm1.LetUserChooseEverything1Click(Sender: TObject);
begin
  ExportListView1.Choose;
end;

procedure TForm1.ExportListView1ExportFinished(Sender: TObject);
const
  cClipSuccessful = 'Successfully Exported to Clipboard';
begin
  if TExportListView(Sender).ExportType = Clipboard then
    ShowMessage(cClipSuccessful);
end;

end.
